Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoIndexedNurbsCurve Class Reference
[Nodes]

`#include <Inventor/nodes/SoIndexedNurbsCurve.h>`

Inheritance diagram for SoIndexedNurbsCurve:

List of all members.

## Detailed Description

The SoIndexedNurbsCurve class is a node for representing smooth curves.

Explaining NURBS is beyond the scope of this documentation. If you are unfamiliar with the principles of representing smooth curves and surfaces when doing 3D visualization, we recommend finding a good book on the subject.

## Public Member Functions
| SoIndexedNurbsCurve (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | sendPrimitive (SoAction *, SoPrimitiveVertex *)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFInt32 | numControlPoints
SoMFInt32 | coordIndex
SoMFFloat | knotVector
## Protected Member Functions
virtual | ~SoIndexedNurbsCurve ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
## Friends
class | SoIndexedNurbsCurveP

## Constructor & Destructor Documentation

SoIndexedNurbsCurve::SoIndexedNurbsCurve | ( | void |  | ) |

| Constructor.

SoIndexedNurbsCurve::~SoIndexedNurbsCurve | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoIndexedNurbsCurve::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoIndexedNurbsCurve::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoIndexedNurbsCurve::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoIndexedNurbsCurve::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoIndexedNurbsCurve::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Redefined to notify open caches that this shape contains lines. Reimplemented from SoShape.

void SoIndexedNurbsCurve::sendPrimitive | ( | SoAction * | ,
|  | SoPrimitiveVertex * |
| ) |

| This method is part of the original SGI Inventor API, but not implemented in Coin, as it looks like a method that should probably have been private in Open Inventor.

void SoIndexedNurbsCurve::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

void SoIndexedNurbsCurve::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

| Calculates the bounding box of all control points, and sets the center to the average of these points. Implements SoShape.

SoDetail * SoIndexedNurbsCurve::createLineSegmentDetail | ( | SoRayPickAction * | action,
|  | const SoPrimitiveVertex * | v1,
|  | const SoPrimitiveVertex * | v2,
|  | SoPickedPoint * | pp
| ) | `[protected, virtual]`

| Will create line detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden). This method returns `NULL` in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint. This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor. For this to work, you must supply a face or line detail when generating primitives. If you supply `NULL` for the detail argument in SoShape::beginShape(), you'll have to override this method. Reimplemented from SoShape.

## Member Data Documentation

SoSFInt32 SoIndexedNurbsCurve::numControlPoints

| Number of control points for this curve.

SoMFInt32 SoIndexedNurbsCurve::coordIndex

| The control point indices. Supply at least numControlPoint indices.

SoMFFloat SoIndexedNurbsCurve::knotVector

| The knot vector.

The documentation for this class was generated from the following files:

- SoIndexedNurbsCurve.h
- SoIndexedNurbsCurve.cpp